Index: context.c
===================================================================
--- context.c	(revision ecd5dc5ca65a64da2e84de5dd1f997d246afd294)
+++ context.c	(revision 53f421bf720d642f4e14ae2b457738a778637264)
@@ -7,5 +7,6 @@
 #define SET_MODE(ctx, new) ctx->mode = ((ctx->mode)&~OWL_CTX_MODE_BITS)|new
 
-int owl_context_init(owl_context *ctx) {
+int owl_context_init(owl_context *ctx)
+{
   ctx->mode = OWL_CTX_STARTUP;
   ctx->data = NULL;
@@ -15,5 +16,6 @@
 
 /* returns whether test matches the current context */
-int owl_context_matches(owl_context *ctx, int test) {
+int owl_context_matches(owl_context *ctx, int test)
+{
   /*owl_function_debugmsg(", current: 0x%04x test: 0x%04x\n", ctx->mode, test);*/
   if ((((ctx->mode&OWL_CTX_MODE_BITS) & test)
@@ -28,51 +30,63 @@
 }
 
-void *owl_context_get_data(owl_context *ctx) {
+void *owl_context_get_data(owl_context *ctx)
+{
   return ctx->data;
 }
 
-int owl_context_get_mode(owl_context *ctx) {
+int owl_context_get_mode(owl_context *ctx)
+{
   return ctx->mode & OWL_CTX_MODE_BITS;
 }
 
-int owl_context_get_active(owl_context *ctx) {
+int owl_context_get_active(owl_context *ctx)
+{
   return ctx->mode & OWL_CTX_ACTIVE_BITS;
 }
 
-int owl_context_is_startup(owl_context *ctx) {
+int owl_context_is_startup(owl_context *ctx)
+{
   return (ctx->mode & OWL_CTX_STARTUP)?1:0;
 }
 
-int owl_context_is_interactive(owl_context *ctx) {
+int owl_context_is_interactive(owl_context *ctx)
+{
   return(ctx->mode & OWL_CTX_INTERACTIVE)?1:0;
 }
 
-void owl_context_set_startup(owl_context *ctx) {
+void owl_context_set_startup(owl_context *ctx)
+{
   SET_MODE(ctx, OWL_CTX_STARTUP);
 }
 
-void owl_context_set_readconfig(owl_context *ctx) {
+void owl_context_set_readconfig(owl_context *ctx)
+{
   SET_MODE(ctx, OWL_CTX_READCONFIG);
 }
 
-void owl_context_set_interactive(owl_context *ctx) {
+void owl_context_set_interactive(owl_context *ctx)
+{
   SET_MODE(ctx, OWL_CTX_INTERACTIVE);
 }
 
-void owl_context_set_popless(owl_context *ctx, owl_viewwin *vw) {
+void owl_context_set_popless(owl_context *ctx, owl_viewwin *vw)
+{
   ctx->data = (void*)vw;
   SET_ACTIVE(ctx, OWL_CTX_POPLESS);
 }
 
-void owl_context_set_recv(owl_context *ctx) {
+void owl_context_set_recv(owl_context *ctx)
+{
   SET_ACTIVE(ctx, OWL_CTX_RECV);
 }
 
-void owl_context_set_editmulti(owl_context *ctx, owl_editwin *ew) {
+void owl_context_set_editmulti(owl_context *ctx, owl_editwin *ew)
+{
   ctx->data = (void*)ew;
   SET_ACTIVE(ctx, OWL_CTX_EDITMULTI);
 }
 
-void owl_context_set_editline(owl_context *ctx, owl_editwin *ew) {
+void owl_context_set_editline(owl_context *ctx, owl_editwin *ew)
+{
   ctx->data = (void*)ew;
   SET_ACTIVE(ctx, OWL_CTX_EDITLINE);
Index: list.c
===================================================================
--- list.c	(revision d09e5a1609d038695dbc6bc34a8177935a9bf7ea)
+++ list.c	(revision 53f421bf720d642f4e14ae2b457738a778637264)
@@ -8,5 +8,6 @@
 #define GROWBY 1.5
 
-int owl_list_create(owl_list *l) {
+int owl_list_create(owl_list *l)
+{
   l->size=0;
   l->list=(void **)owl_malloc(INITSIZE*sizeof(void *));
@@ -16,14 +17,17 @@
 }
 
-int owl_list_get_size(owl_list *l) {
+int owl_list_get_size(owl_list *l)
+{
   return(l->size);
 }
 
-void *owl_list_get_element(owl_list *l, int n) {
+void *owl_list_get_element(owl_list *l, int n)
+{
   if (n>l->size-1) return(NULL);
   return(l->list[n]);
 }
 
-int owl_list_append_element(owl_list *l, void *element) {
+int owl_list_append_element(owl_list *l, void *element)
+{
   void *ptr;
   
@@ -40,5 +44,6 @@
 }
 
-int owl_list_prepend_element(owl_list *l, void *element) {
+int owl_list_prepend_element(owl_list *l, void *element)
+{
   void *ptr;
   int i;
@@ -59,5 +64,6 @@
 }
 
-int owl_list_remove_element(owl_list *l, int n) {
+int owl_list_remove_element(owl_list *l, int n)
+{
   int i;
 
@@ -71,5 +77,6 @@
 
 /* todo: might leak memory */
-int owl_list_replace_element(owl_list *l, int n, void *element) {
+int owl_list_replace_element(owl_list *l, int n, void *element)
+{
   if (n>l->size-1) return(-1);
 
@@ -78,5 +85,6 @@
 }
 
-void owl_list_free_all(owl_list *l, void (*elefree)(void *)) {
+void owl_list_free_all(owl_list *l, void (*elefree)(void *))
+{
   int i;
 
@@ -87,5 +95,6 @@
 }
 
-void owl_list_free_simple(owl_list *l) {
+void owl_list_free_simple(owl_list *l)
+{
   if (l->list) owl_free(l->list);
 }