Index: cmd.c
===================================================================
--- cmd.c	(revision c529ac8bb1d8b29ebbfc9c8c4d856b1a5fa687a8)
+++ cmd.c	(revision 65b21736092356a35d24e53dc2e6b92e13174131)
@@ -170,5 +170,6 @@
   static int alias_recurse_depth = 0;
   int ival=0;
-  char *cmdbuffargs, *newcmd, *rv=NULL;
+  char *cmdbuffargs;
+  char *newcmd, *rv=NULL;
 
   if (argc < 1) return(NULL);
@@ -255,5 +256,6 @@
 
 void owl_cmd_get_help(owl_cmddict *d, char *name, owl_fmtext *fm) {
-  char *indent, *s;
+  char *s;
+  char *indent;
   owl_cmd *cmd;
 
Index: commands.c
===================================================================
--- commands.c	(revision bc9020fb25e57fb6a646687b39c8adc89db69538)
+++ commands.c	(revision 65b21736092356a35d24e53dc2e6b92e13174131)
@@ -1886,5 +1886,6 @@
 char *owl_command_aimwrite(int argc, char **argv, char *buff)
 {
-  char *newbuff, *recip, **myargv;
+  char *newbuff, *recip;
+  char **myargv;
   int i, j, myargc;
   owl_message *m;
Index: editwin.c
===================================================================
--- editwin.c	(revision 0509efcfb2852cfdb940e38b846fcb8516aabdca)
+++ editwin.c	(revision 65b21736092356a35d24e53dc2e6b92e13174131)
@@ -694,5 +694,6 @@
 void owl_editwin_transpose_chars(owl_editwin *e)
 {
-  char *middle, *end, *start, *tmp;
+  char *middle, *end, *start;
+  char *tmp;
 
   if (e->bufflen == 0) return;
Index: filterelement.c
===================================================================
--- filterelement.c	(revision 41c9a9675faf455c3c6adfbc629faf55ddbfe10f)
+++ filterelement.c	(revision 65b21736092356a35d24e53dc2e6b92e13174131)
@@ -79,5 +79,6 @@
 static int owl_filterelement_match_perl(owl_filterelement *fe, owl_message *m)
 {
-  char *subname, *perlrv;
+  char *subname;
+  char *perlrv;
   int   tf=0;
 
Index: fmtext.c
===================================================================
--- fmtext.c	(revision 41c9a9675faf455c3c6adfbc629faf55ddbfe10f)
+++ fmtext.c	(revision 65b21736092356a35d24e53dc2e6b92e13174131)
@@ -568,5 +568,6 @@
 {
   int stacksize, curattrs, curcolor;
-  char *ptr, *txtptr, *buff, *tmpptr;
+  char *ptr, *txtptr, *tmpptr;
+  char *buff;
   int attrstack[32], chrstack[32], colorstack[32];
 
Index: functions.c
===================================================================
--- functions.c	(revision 712caac5659285580c2d4e676ebf61794d84704d)
+++ functions.c	(revision 65b21736092356a35d24e53dc2e6b92e13174131)
@@ -93,5 +93,6 @@
 
 char *owl_function_style_describe(char *name) {
-  char *desc, *s;
+  char *desc;
+  char *s;
   owl_style *style;
   style = owl_global_get_style_by_name(&g, name);
@@ -500,5 +501,6 @@
 {
   int ret;
-  char *to, *format_msg;
+  char *to;
+  char *format_msg;
   owl_message *m;
 
@@ -882,5 +884,6 @@
 {
   int ret, ret2;
-  char *foo, *path;
+  char *foo;
+  char *path;
 
   if (file==NULL) {
@@ -2016,5 +2019,6 @@
    * else display in a popup
    */
-  char *newbuff, *redirect = " 2>&1 < /dev/null";
+  char *redirect = " 2>&1 < /dev/null";
+  char *newbuff;
   char *out, buff2[1024];
   int size;
@@ -2649,5 +2653,6 @@
   owl_view *v;
   owl_message *m;
-  char *cmd, *cmdprefix, *mclass, *minst;
+  char *cmdprefix, *mclass, *minst;
+  char *cmd;
   
   v=owl_global_get_current_view(&g);
@@ -3078,5 +3083,6 @@
   int x;
   owl_list anyone;
-  char *tmp, *user;
+  char *user;
+  char *tmp;
   ZLocations_t location[200];
   int numlocs, ret;
Index: global.c
===================================================================
--- global.c	(revision 41c9a9675faf455c3c6adfbc629faf55ddbfe10f)
+++ global.c	(revision 65b21736092356a35d24e53dc2e6b92e13174131)
@@ -759,5 +759,6 @@
 void owl_global_set_aimloggedin(owl_global *g, char *screenname)
 {
-  char *sn_escaped, *quote;
+  char *sn_escaped;
+  char *quote;
   g->aim_loggedin=1;
   if (g->aim_screenname) owl_free(g->aim_screenname);
Index: logging.c
===================================================================
--- logging.c	(revision d43edd2156ec9694ba4cec1c13baba690ce46b19)
+++ logging.c	(revision 65b21736092356a35d24e53dc2e6b92e13174131)
@@ -230,5 +230,6 @@
 {
   char filename[MAXPATHLEN], allfilename[MAXPATHLEN], *logpath;
-  char *frombuff=NULL, *from=NULL;
+  char *from=NULL;
+  char *frombuff=NULL;
   int len, ch, i, personal;
 
Index: message.c
===================================================================
--- message.c	(revision 41c9a9675faf455c3c6adfbc629faf55ddbfe10f)
+++ message.c	(revision 65b21736092356a35d24e53dc2e6b92e13174131)
@@ -568,5 +568,6 @@
 char *owl_message_get_cc(owl_message *m)
 {
-  char *cur, *out, *end;
+  char *cur;
+  char *out, *end;
 
   cur = owl_message_get_body(m);
@@ -584,5 +585,6 @@
 char *owl_message_get_cc_without_recipient(owl_message *m)
 {
-  char *cc, *out, *end, *user, *shortuser, *recip;
+  char *cc, *out, *end, *shortuser, *recip;
+  char *user;
 
   cc = owl_message_get_cc(m);
@@ -735,5 +737,6 @@
 {
   struct hostent *hent;
-  char *ptr, *tmp, *tmp2;
+  char *ptr;
+  char *tmp, *tmp2;
   int len;
 
@@ -851,5 +854,6 @@
 void owl_message_create_pseudo_zlogin(owl_message *m, int direction, char *user, char *host, char *time, char *tty)
 {
-  char *longuser, *ptr;
+  char *longuser;
+  char *ptr;
 
 #ifdef HAVE_LIBZEPHYR
Index: owl.c
===================================================================
--- owl.c	(revision c529ac8bb1d8b29ebbfc9c8c4d856b1a5fa687a8)
+++ owl.c	(revision 65b21736092356a35d24e53dc2e6b92e13174131)
@@ -44,5 +44,6 @@
   int newmsgs, nexttimediff;
   struct sigaction sigact;
-  char *configfile, *tty, *perlout, *perlerr, **argvsave;
+  char *configfile, *tty, **argvsave;
+  char *perlout, *perlerr;
   char *confdir;
   owl_filter *f;
Index: perlconfig.c
===================================================================
--- perlconfig.c	(revision 712caac5659285580c2d4e676ebf61794d84704d)
+++ perlconfig.c	(revision 65b21736092356a35d24e53dc2e6b92e13174131)
@@ -381,5 +381,6 @@
   STRLEN len;
   SV *response;
-  char *out, *preout;
+  char *preout;
+  char *out;
 
   if (!owl_global_have_config(&g)) return NULL;
Index: style.c
===================================================================
--- style.c	(revision d43edd2156ec9694ba4cec1c13baba690ce46b19)
+++ style.c	(revision 65b21736092356a35d24e53dc2e6b92e13174131)
@@ -41,5 +41,6 @@
 void owl_style_get_formattext(owl_style *s, owl_fmtext *fm, owl_message *m)
 {
-  char *body, *indent;
+  char *body;
+  char *indent;
   int curlen;
 
Index: text.c
===================================================================
--- text.c	(revision 64c9165b238b9b34553b372b7eecbc23e3b9b206)
+++ text.c	(revision 65b21736092356a35d24e53dc2e6b92e13174131)
@@ -48,5 +48,6 @@
 char *owl_text_htmlstrip(char *in)
 {
-  char *ptr1, *end, *ptr2, *ptr3, *out, *out2;
+  char *ptr1, *end, *ptr2, *ptr3;
+  char *out, *out2;
 
   out=owl_malloc(strlen(in)+30);
Index: util.c
===================================================================
--- util.c	(revision 4d86e066c8f1fe00bd18a85523b809ba4c968947)
+++ util.c	(revision 65b21736092356a35d24e53dc2e6b92e13174131)
@@ -456,5 +456,6 @@
 char *owl_util_get_default_tty()
 {
-  char *out, *tmp;
+  char *tmp;
+  char *out;
 
   if (getenv("DISPLAY")) {
Index: zcrypt.c
===================================================================
--- zcrypt.c	(revision 0fa074587f6e4a2d5a466a7082dc7e47ec71417d)
+++ zcrypt.c	(revision 65b21736092356a35d24e53dc2e6b92e13174131)
@@ -70,5 +70,6 @@
  */
 int owl_zcrypt_decrypt(char *out, char *in, char *class, char *instance) {
-  char *fname, keystring[MAX_KEY], *inptr, *endptr;
+  char *inptr, *endptr;
+  char *fname, keystring[MAX_KEY];
   FILE *fkey;
   des_cblock key;
Index: zwrite.c
===================================================================
--- zwrite.c	(revision c529ac8bb1d8b29ebbfc9c8c4d856b1a5fa687a8)
+++ zwrite.c	(revision 65b21736092356a35d24e53dc2e6b92e13174131)
@@ -8,5 +8,6 @@
 {
   int argc, badargs, myargc, i, len;
-  char **argv, **myargv;
+  char **argv;
+  char **myargv;
   char *msg = NULL;
 
@@ -151,5 +152,6 @@
 void owl_zwrite_populate_zsig(owl_zwrite *z)
 {
-  char *zsigproc, *zsigowlvar, *zsigzvar, *ptr;
+  char *zsigproc, *zsigowlvar, *zsigzvar;
+  char *ptr;
   struct passwd *pw;
 