Index: fmtext.c
===================================================================
--- fmtext.c	(revision e19eb97bacd75cf02905ec2b7a6a73b9642b907a)
+++ fmtext.c	(revision 075ba9227278b95ec4f4728f4a91eee4a2e438b7)
@@ -170,5 +170,5 @@
 
 /* Internal function. Scan for attribute characters. */
-void _owl_fmtext_scan_attributes(owl_fmtext *f, int start, char *attr, short *fgcolor, short *bgcolor) /*noproto*/
+void _owl_fmtext_scan_attributes(const owl_fmtext *f, int start, char *attr, short *fgcolor, short *bgcolor) /*noproto*/
 {
   const char *p;
@@ -184,5 +184,5 @@
  * bytes.
  */
-void _owl_fmtext_append_fmtext(owl_fmtext *f, owl_fmtext *in, int start, int stop) /*noproto*/
+void _owl_fmtext_append_fmtext(owl_fmtext *f, const owl_fmtext *in, int start, int stop) /*noproto*/
 {
   char attrbuff[6];
@@ -230,5 +230,5 @@
 
 /* append fmtext 'in' to 'f' */
-void owl_fmtext_append_fmtext(owl_fmtext *f, owl_fmtext *in)
+void owl_fmtext_append_fmtext(owl_fmtext *f, const owl_fmtext *in)
 {
   _owl_fmtext_append_fmtext(f, in, 0, in->textlen);
@@ -248,5 +248,5 @@
  * freeing the return
  */
-char *owl_fmtext_print_plain(owl_fmtext *f)
+char *owl_fmtext_print_plain(const owl_fmtext *f)
 {
   return owl_strip_format_chars(f->textbuff);
@@ -278,5 +278,5 @@
  * must already be initiatlized with curses
  */
-void _owl_fmtext_curs_waddstr(owl_fmtext *f, WINDOW *w, int do_search) /*noproto*/
+void _owl_fmtext_curs_waddstr(const owl_fmtext *f, WINDOW *w, int do_search) /*noproto*/
 {
   /* char *tmpbuff; */
@@ -367,10 +367,10 @@
 }
 
-void owl_fmtext_curs_waddstr(owl_fmtext *f, WINDOW *w)
+void owl_fmtext_curs_waddstr(const owl_fmtext *f, WINDOW *w)
 {
   _owl_fmtext_curs_waddstr(f, w, owl_global_is_search_active(&g));
 }
 
-void owl_fmtext_curs_waddstr_without_search(owl_fmtext *f, WINDOW *w)
+void owl_fmtext_curs_waddstr_without_search(const owl_fmtext *f, WINDOW *w)
 {
   _owl_fmtext_curs_waddstr(f, w, 0);
@@ -380,5 +380,5 @@
  * 'lines' number of lines into 'out'
  */
-int owl_fmtext_truncate_lines(owl_fmtext *in, int aline, int lines, owl_fmtext *out)
+int owl_fmtext_truncate_lines(const owl_fmtext *in, int aline, int lines, owl_fmtext *out)
 {
   const char *ptr1, *ptr2;
@@ -424,5 +424,5 @@
  * character and stop there.
  */
-void owl_fmtext_truncate_cols(owl_fmtext *in, int acol, int bcol, owl_fmtext *out)
+void owl_fmtext_truncate_cols(const owl_fmtext *in, int acol, int bcol, owl_fmtext *out)
 {
   const char *ptr_s, *ptr_e, *ptr_c, *last;
@@ -500,5 +500,5 @@
 
 /* Return the number of lines in 'f' */
-int owl_fmtext_num_lines(owl_fmtext *f)
+int owl_fmtext_num_lines(const owl_fmtext *f)
 {
   int lines, i;
@@ -517,5 +517,5 @@
 }
 
-const char *owl_fmtext_get_text(owl_fmtext *f)
+const char *owl_fmtext_get_text(const owl_fmtext *f)
 {
   return(f->textbuff);
@@ -534,5 +534,5 @@
 
 /* Make a copy of the fmtext 'src' into 'dst' */
-void owl_fmtext_copy(owl_fmtext *dst, owl_fmtext *src)
+void owl_fmtext_copy(owl_fmtext *dst, const owl_fmtext *src)
 {
   int mallocsize;
@@ -555,5 +555,5 @@
  *  insensitive search.
  */
-int owl_fmtext_search(owl_fmtext *f, owl_regex *re)
+int owl_fmtext_search(const owl_fmtext *f, owl_regex *re)
 {
   if (owl_regex_compare(re, f->textbuff, NULL, NULL) == 0) return(1);
Index: functions.c
===================================================================
--- functions.c	(revision 1077891a70f9f4c4b766de9b7d6d481d7805bb88)
+++ functions.c	(revision 075ba9227278b95ec4f4728f4a91eee4a2e438b7)
@@ -1343,5 +1343,5 @@
 }
 
-void owl_function_popless_fmtext(owl_fmtext *fm)
+void owl_function_popless_fmtext(const owl_fmtext *fm)
 {
   owl_popwin *pw;
Index: viewwin.c
===================================================================
--- viewwin.c	(revision e19eb97bacd75cf02905ec2b7a6a73b9642b907a)
+++ viewwin.c	(revision 075ba9227278b95ec4f4728f4a91eee4a2e438b7)
@@ -33,5 +33,5 @@
  * window that will be used by viewwin
  */
-void owl_viewwin_init_fmtext(owl_viewwin *v, WINDOW *win, int winlines, int wincols, owl_fmtext *fmtext)
+void owl_viewwin_init_fmtext(owl_viewwin *v, WINDOW *win, int winlines, int wincols, const owl_fmtext *fmtext)
 {
   owl_fmtext_copy(&(v->fmtext), fmtext);